import { DynamoDB } from "aws-sdk";
import { IDynamoDBService } from "./IDynamoDBService";
export declare class DynamoDBService implements IDynamoDBService {
    private dynamoDb;
    private documentClient;
    constructor();
    /**
     * If your want to try the `scan` using AWS CLI you can use this:
     *
     * $ aws dynamodb scan --table-name dickbott_dev_schedules
     *
     */
    scan(params: DynamoDB.Types.ScanInput): Promise<DynamoDB.Types.ScanOutput>;
    putItem(params: DynamoDB.Types.PutItemInput): Promise<DynamoDB.Types.PutItemOutput>;
    updateItem(params: DynamoDB.Types.UpdateItemInput): Promise<DynamoDB.Types.UpdateItemOutput>;
    getItem(params: DynamoDB.Types.GetItemInput): Promise<DynamoDB.Types.GetItemOutput>;
    get(params: DynamoDB.Types.DocumentClient.GetItemInput): Promise<DynamoDB.Types.DocumentClient.GetItemOutput>;
    put(params: DynamoDB.Types.DocumentClient.PutItemInput): Promise<DynamoDB.Types.DocumentClient.PutItemOutput>;
}
