"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var aws_sdk_1 = require("aws-sdk");
var inversify_1 = require("inversify");
var lodash_1 = require("lodash");
var EC2Service = /** @class */ (function () {
    function EC2Service() {
        this.ec2 = new aws_sdk_1.EC2();
    }
    EC2Service.prototype.describeInstances = function (params) {
        return this.ec2.describeInstances(params).promise().then(function (result) { return lodash_1.flatMap(result.Reservations, function (reservation) { return reservation.Instances; }); });
    };
    EC2Service.prototype.stopInstances = function (params) {
        return this.ec2.stopInstances(params).promise();
    };
    EC2Service.prototype.startInstances = function (params) {
        return this.ec2.startInstances(params).promise();
    };
    EC2Service.prototype.describeVpnConnections = function (params) {
        return this.ec2.describeVpnConnections(params).promise();
    };
    EC2Service.prototype.describeImages = function (params) {
        return this.ec2.describeImages(params).promise();
    };
    EC2Service = __decorate([
        inversify_1.injectable(),
        __metadata("design:paramtypes", [])
    ], EC2Service);
    return EC2Service;
}());
exports.EC2Service = EC2Service;
