"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var containerDecorators_1 = require("./utils/containerDecorators");
var DickBottModule_1 = require("../modules/DickBottModule");
var DickBottEngine = /** @class */ (function () {
    function DickBottEngine() {
        this.modules = [];
        this.container = containerDecorators_1.DefaultContainer;
        this.register(new DickBottModule_1.DickBottModule());
    }
    DickBottEngine.prototype.register = function (module) {
        if (module.modules) {
            module.modules(this.container);
        }
        this.modules.push(module);
        return true;
    };
    DickBottEngine.prototype.getService = function (serviceIdentifier) {
        return this.container.get(serviceIdentifier);
    };
    return DickBottEngine;
}());
exports.DickBottEngine = DickBottEngine;
