export interface FulfillmentRequest {
    originalRequest: OriginalRequest;
    result: Result;
}
export declare type FulfillmentResponse = {
    speech?: string;
    displayText?: string;
    data?: {
        slack?: any;
    };
};
export declare type Result = {
    action: string;
    parameters?: any;
    metadata: Metadata;
};
export declare type Metadata = {
    intentName: string;
};
export declare type OriginalRequest = {
    source: Provider;
    data: {
        authed_users: string[];
        event_id: string;
        api_app_id: string;
        team_id: string;
        event: {
            event_ts: string;
            channel: string;
            text: string;
            type: EventType;
            user: string;
            ts: string;
        };
        type: string;
        event_time: number;
        token: string;
    };
};
export declare enum Provider {
    Slack = "slack",
}
export declare enum EventType {
    Message = "message",
}
