"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var _ = require("lodash");
var IntroduceYourselfIntent = /** @class */ (function () {
    function IntroduceYourselfIntent(container) {
        this.container = container;
        this.name = "Introduce Yourself";
        this.examples = {
            Simple: "Introduce yourself",
            Elegant: "Please, can you introduce yourself?"
        };
        this.docs_url = "https://bitbucket.tierratelematics.com";
    }
    IntroduceYourselfIntent.prototype.execute = function (executionId, entities) {
        return __awaiter(this, void 0, void 0, function () {
            var intents, attachments;
            return __generator(this, function (_a) {
                intents = this.container.getAll("Intent");
                attachments = _(intents)
                    .map(function (intent) { return ({
                    attachment_type: "default",
                    title: intent.name,
                    title_link: intent.docs_url,
                    text: "I will introduce myself describing what I am, what is my value proposition is and what I'm capable of doing right now.",
                    fields: _(intent.examples).map(function (value, key) { return ({
                        short: true,
                        title: key,
                        value: "\"" + value + "\""
                    }); }).value(),
                    color: "#d2dde1",
                    mrkdwn_in: [
                        "text",
                        "pretext",
                        "fields"
                    ]
                }); })
                    .value();
                return [2 /*return*/, {
                        text: "I am a chatbot designed to help you with your infrastructure duties.\n\nThis is the list of what I'm capable of doing today for you.",
                        attachments: attachments
                    }];
            });
        });
    };
    IntroduceYourselfIntent = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject("Container")),
        __metadata("design:paramtypes", [Object])
    ], IntroduceYourselfIntent);
    return IntroduceYourselfIntent;
}());
exports.IntroduceYourselfIntent = IntroduceYourselfIntent;
