"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var jenkinsapi = require("jenkins");
/**
 * See https://github.com/silas/node-jenkins for the Jenkins API library used.
 *
 * See https://wiki.jenkins.io/display/JENKINS/Authenticating+scripted+clients for
 * more details on the Jenkins API.
 */
var JenkinsService = /** @class */ (function () {
    function JenkinsService(jenkinsConfig) {
        this.jenkins = jenkinsapi(jenkinsConfig);
    }
    JenkinsService.prototype.build = function (job) {
        console.log("launching job %j", job);
        return this.jenkins.job.build(job);
        // console.log("Job launch disabled");
        // return Promise.resolve(0);
    };
    JenkinsService.prototype.info = function () {
        return this.jenkins.info();
    };
    JenkinsService = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject("JenkinsConfig")),
        __metadata("design:paramtypes", [Object])
    ], JenkinsService);
    return JenkinsService;
}());
exports.JenkinsService = JenkinsService;
