"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var HttpClient_1 = require("../core/http/HttpClient");
var SlackWebAPI_1 = require("../slack/SlackWebAPI");
var JenkinsService_1 = require("../jenkins/JenkinsService");
var EC2Service_1 = require("../aws/ec2/EC2Service");
var AutoScalingService_1 = require("../aws/autoscaling/AutoScalingService");
var IntentDispatcher_1 = require("../core/dispatcher/IntentDispatcher");
var DynamoDBService_1 = require("../aws/dynamodb/DynamoDBService");
// import { DynamoDBIntentRepository } from "../aws/dynamodb/DynamoDBIntentRepository";
var InMemoryIntentRepository_1 = require("../core/intent/InMemoryIntentRepository");
var IntroduceYourselfIntent_1 = require("../intents/IntroduceYourselfIntent");
var DickBottModule = /** @class */ (function () {
    function DickBottModule() {
        this.modules = function (container) {
            // Core
            container.bind("Container").toConstantValue(container);
            container.bind("IntentDispatcher").to(IntentDispatcher_1.IntentDispatcher).inSingletonScope();
            container.bind("IntentRepository").to(InMemoryIntentRepository_1.InMemoryIntentRepository).inSingletonScope();
            container.bind("HttpClient").to(HttpClient_1.HttpClient).inSingletonScope();
            container.bind("ISlackWebAPI").to(SlackWebAPI_1.SlackWebAPI).inSingletonScope();
            // Services
            container.bind("EC2Service").to(EC2Service_1.EC2Service).inSingletonScope();
            container.bind("AutoScalingService").to(AutoScalingService_1.AutoScalingService).inSingletonScope();
            container.bind("JenkinsService").to(JenkinsService_1.JenkinsService).inSingletonScope();
            container.bind("DynamoDBService").to(DynamoDBService_1.DynamoDBService).inSingletonScope();
            // Intents
            container.bind("Intent").to(IntroduceYourselfIntent_1.IntroduceYourselfIntent).whenTargetNamed("IntroduceYourselfIntent");
        };
    }
    return DickBottModule;
}());
exports.DickBottModule = DickBottModule;
